# prebrl.rb  2008.10.05
# Copyright (C) T. Yoshiizumi, 2008 All rights reserved.
# VEBRL.EXȄo͌ʂŒ₷`ɒB
# VEBTOK.EXEŃeLXgϊO̎OB

## BRLt@C̎O
def pre_brl_conv(fname)
  infile = open(fname)
  list = []
  while line = infile.gets
    line = line.chomp

    # BRLt@C_L̘g
    line = line.gsub(/6333+4|FCCC+D|PCCC+\?/, "6\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f4")
    line = line.gsub(/H333+J|8---+0|V---+#/, "H\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7fJ")
    line = line.gsub(/\(777+\)|QGGG+\]/, "")
    line = line.gsub(/[L_X=][L_X=G7C3-]{3,}[L_X=]|(\[[=XG7C3-]+O){3,}/, "")
    line = line.gsub(/[L_X=]+[\[O]{3,}[L_X=]+/, "")
    line = line.gsub(/[L_X=]+[\[O]{3,}/, "")
    line = line.gsub(/[\[O]{3,}[L_X=]+/, "")
    line = line.sub(/^\[?[L_X=]+ /, "")
    line = line.sub(/ [L_X=]+O?$/, "")
    line = line.gsub(/ [L_X=]+O? +\[?[L_X=]+ /, "  ")
    line = line.gsub(/ \[?[L_X=]+O? /, "")
    line = line.gsub(/[C3-]+[\[O][\[O][C3-]+/, "")
    line = line.gsub(/[\[O][\[O][C3-]+[\[O][\[O]/, "")
    line = line.gsub(/( *[\[O][\[O] *){2,}/, "")
    line = line.gsub(/^ *[\[O][\[O] *$/, "")
    line = line.gsub(/[C3-]{3,}/, "")
    line = line.gsub(/[\[O]{3,}|[G7]{3,}|[L_X=]{3,}/, "")
    line = line.gsub(/[OR][\[O3]{3,}[\[W]/, "")

    # L_L̐؂藣
    line = line.sub(/(#[A-J]+)(#[A-J]+)/, '\1; \2')  while  line =~ /(#[A-J]+)(#[A-J]+)/

    # 萔ʏ̐ɕϊ
    line = line.gsub(/#[0-9]+/) {|m| m = m.tr("0123456789", "JABCDEFGHI")}

    line = line.gsub(/\x7f/, "3")

    list.push(line)
  end
  infile.close

  outfile = open(fname, "w")
  while line = list.shift
    outfile.printf("%s\n", line)
  end
  outfile.close
end

## main
for fname in ARGV
  next  unless test(?e, fname)
  next  unless fname.downcase =~ /\.brl$/
  pre_brl_conv(fname)
end
